<?php 
global $SocialAutoPost,$wpdb;

if(isset($_POST['item']) && is_array($_POST['item']) && !empty($_POST['item'])){
    foreach($_POST['item'] as $uid => $item){
        $content_type= $SocialAutoPost->value($item,'content_type');
        $format=$SocialAutoPost->value($item,'format');
        $categories=$SocialAutoPost->value($item,'categories');
        $start_pid=(int) $SocialAutoPost->value($item,'start_pid');
        $days_repost=(int) $SocialAutoPost->value($item,'days_repost');
        $status=($days_repost==0) ? 0:1;
        $wpdb->update( 
            $SocialAutoPost->get('db_prefix').'log', 
            array(
                'status'=>$status
            ),
            array('uid'=>$uid)
        );
        
        $fields=array(
            'content_type'=>(!empty($content_type)) ? implode(',',$content_type) : '',
            'format'=>(!empty($format)) ? implode(',',$format) : '',
            'categories'=>(!empty($categories)) ? implode(',',$categories) : '',
            'start_pid'=>$start_pid,
            'days_repost'=>$days_repost
        );
        $wpdb->update( $SocialAutoPost->get('db_prefix').'account',$fields,array('id'=>$uid));
        
    }
    $SocialAutoPost->message('Update successfully Configuration');
    if(isset($_GET['paged'])) $_REQUEST['paged']=$_GET['paged'];
}
?>
<h2>
    <a href="<?php echo add_query_arg(array('provider'=>'Google','logout'=>true), site_url('social-auto-post/sign-in'));?>" class="page-title-action" >add New Google Account</a>
</h2>

<?php
if (!class_exists('WP_List_Table')) {
    require_once(ABSPATH . 'wp-admin/includes/class-wp-list-table.php');
}

/**
 * Custom_Table_Example_List_Table class that will display our custom table
 * records in nice table
 */
class TwitterList extends WP_List_Table
{
    /**
     * [REQUIRED] You must declare constructor and give some basic params
     */
    function __construct()
    {
        global $status, $page ,$SocialAutoPost;

        parent::__construct(array(
            'singular' => 'list',
            'plural' => 'lists',
        ));
    }

    /**
     * [REQUIRED] this is a default column renderer
     *
     * @param $item - row (key, value array)
     * @param $column_name - string (key)
     * @return HTML
     */
    function column_default($item, $column_name)
    {
        return $item[$column_name];
    }
    
    

    /**
     * [OPTIONAL] this is example, how to render column with actions,
     * when you hover row "Edit | Delete" links showed
     *
     * @param $item - row (key, value array)
     * @return HTML
     */
    function column_created($item)
    {
        return date('Y-m-d h:i:s',$item['created']);
    }
    
    function column_name($item)
    {
        return sprintf('<a href="%s" target="_blank">%s</a>',$item['profileURL'],$item['name']);
    }
    
    function column_settings($item)
    {
        global $SocialAutoPost;
        
        return $SocialAutoPost->loadContent('admin/settings.tpl.php',array('item'=>$item));
    }

    function column_cb($item)
    {
        return sprintf(
            '<input type="checkbox" name="id[]" value="%s" />',
            $item['id']
        );
    }

    /**
     * [REQUIRED] This method return columns to display in table
     * you can skip columns that you do not want to show
     * like content, or description
     *
     * @return array
     */
    function get_columns()
    {
        $columns = array(
            'cb' => '<input type="checkbox" />', //Render a checkbox instead of text
            'name' => __('Name'),
            
            'settings' => __('Settings')
        );
        return $columns;
    }

    /**
     * [OPTIONAL] This method return columns that may be used to sort table
     * all strings in array - is column names
     * notice that true on name column means that its default sort
     *
     * @return array
     */
    function get_sortable_columns()
    {
        $sortable_columns = array(
            'name' => array('name', false)
        );
        return $sortable_columns;
    }

    /**
     * [OPTIONAL] Return array of bult actions if has any
     *
     * @return array
     */
    function get_bulk_actions()
    {
        $actions = array(
            'delete' => 'Delete'
        );
        return $actions;
    }

    /**
     * [OPTIONAL] This method processes bulk actions
     * it can be outside of class
     * it can not use wp_redirect coz there is output already
     * in this example we are processing delete action
     * message about successful deletion will be shown on page in next part
     */
    function process_bulk_action()
    {
        global $wpdb,$SocialAutoPost;
        $table_name = $SocialAutoPost->get('db_prefix'). 'account'; // do not forget about tables prefix

        if ('delete' === $this->current_action()) {
            $ids = isset($_REQUEST['id']) ? $_REQUEST['id'] : array();
            if (is_array($ids)) $ids = implode(',', $ids);

            if (!empty($ids)) {
                $wpdb->query("DELETE FROM $table_name WHERE id IN($ids)");
                $SocialAutoPost->message('Delete successfully');
            }
        }
        
    }

    /**
     * [REQUIRED] This is the most important method
     *
     * It will get rows from database and prepare them to be showed in table
     */
    function prepare_items()
    {
        global $wpdb ,$SocialAutoPost;
        $table_name = $SocialAutoPost->get('db_prefix'). 'account'; // do not forget about tables prefix

        $per_page = 10; // constant, how much records will be shown per page

        $columns = $this->get_columns();
        $hidden = array();
        $sortable = $this->get_sortable_columns();

        // here we configure table headers, defined in our methods
        $this->_column_headers = array($columns, $hidden, $sortable);

        // [OPTIONAL] process bulk action if any
        $this->process_bulk_action();

        
        
        // will be used in pagination settings
        $total_items = $wpdb->get_var("SELECT COUNT(id) FROM $table_name where provider='Google' ");
        
        // prepare query params, as usual current page, order by and order direction
        $paged = isset($_REQUEST['paged']) ? max(0, intval($_REQUEST['paged']) - 1) : 0;
        
        
        
        $orderby = (isset($_REQUEST['orderby']) && in_array($_REQUEST['orderby'], array_keys($this->get_sortable_columns()))) ? $_REQUEST['orderby'] : 'id';
        $order = (isset($_REQUEST['order']) && in_array($_REQUEST['order'], array('asc', 'desc'))) ? $_REQUEST['order'] : 'asc';

        // [REQUIRED] define $items array
        // notice that last argument is ARRAY_A, so we will retrieve array
        $this->items = $wpdb->get_results($wpdb->prepare("SELECT * FROM $table_name where provider='Google'  ORDER BY $orderby $order LIMIT %d , %d", $per_page*$paged,($paged+1)*$per_page), ARRAY_A);

        
        // [REQUIRED] configure pagination
        $this->set_pagination_args(array(
            'total_items' => $total_items, // total items defined above
            'per_page' => $per_page, // per page constant defined at top of method
            'total_pages' => ceil($total_items / $per_page) // calculate pages count
        ));
    }
}
?>

<?php

$table = new TwitterList();
$table->prepare_items();

$message = '';
if ('delete' === $table->current_action()) {
    $message = '<div class="updated below-h2" id="message"><p>' . sprintf(__('Items deleted: %d'), count($_REQUEST['id'])) . '</p></div>';
}
?>
<div class="wrap">
    
    <div class="col-wrap">
        
        <form  method="POST" id="acc-configuration">
            <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>"/>
            <?php $table->display() ?>
            <p class="submit">
                <input type="submit" name="submit" id="acc_save" class="button button-primary" value="Save Configuration">
            </p>
        </form>
        
    </div>
</div>
