<?php
global $wp,$wpdb ,$SocialAutoPost;

try{
    ob_start();
    $providers=$SocialAutoPost->variable_get('settings',array());
    
    if(isset($_REQUEST['provider']) && array_key_exists($_REQUEST['provider'],$providers) && !array_key_exists('enabled',$providers[$_REQUEST['provider']])){
        $providers[$_REQUEST['provider']]['enabled']=false;
    }

    $config = array(
        "base_url" => site_url('social-auto-post/auth'),
        "providers" => $providers
    );
    
    $hybridauth = new Hybrid_Auth( $config );

    if(isset($_REQUEST['logout'])){
        $hybridauth->logoutAllProviders();
        if(isset($_REQUEST['provider']) && $_REQUEST['provider']=='LinkedIn'){
            wp_redirect(add_query_arg(array('hauth.done'=>$_REQUEST['provider'],'login'=>1), site_url('social-auto-post/auth')));
            exit();
        }
        wp_redirect(add_query_arg(array('provider'=>$_REQUEST['provider']), site_url('social-auto-post/sign-in')));
        exit();
    }
    
    $provider = $hybridauth->authenticate($_REQUEST['provider']);
    
    $user_profile = $provider->getUserProfile();
    
    
    
    if(!empty($user_profile) && $_REQUEST['provider']=='Twitter'){
        $access_token_arr=$provider->getAccessToken();
        $identifier=$SocialAutoPost->value($user_profile,'identifier');
        $r=$wpdb->get_row( "SELECT * FROM ".$SocialAutoPost->get('db_prefix')."account where identifier='{$identifier}' limit 0,1",ARRAY_A);
        $fields=array(
            'provider'=>$_REQUEST['provider'],
            'identifier'=>$SocialAutoPost->value($user_profile,'identifier'),
            'access_token'=>$SocialAutoPost->value($access_token_arr,'access_token'),
            'access_token_secret'=>$SocialAutoPost->value($access_token_arr,'access_token_secret'),
            'name'=>$SocialAutoPost->value($user_profile,'displayName'),
            'created'=>time(),
            'type'=>'Account',
            'profileURL'=>$SocialAutoPost->value($user_profile,'profileURL'),
        );
        if(!$r){
             $wpdb->insert( $SocialAutoPost->get('db_prefix').'account',$fields);
        }
        else {
            $wpdb->update( $SocialAutoPost->get('db_prefix').'account',$fields,array('identifier'=>$identifier));
        }
                
    }
    else if(!empty($user_profile) && $_REQUEST['provider']=='Facebook'){
        
        $access_token_arr=$provider->getAccessToken();
        $access_token=$SocialAutoPost->value($access_token_arr,'access_token');
        $listPage= json_decode($SocialAutoPost->contents_get('https://graph.facebook.com/me/accounts',array('access_token'=>$access_token,'limit'=>1000)));
        $data=$SocialAutoPost->value($listPage,'data');
        
        $listGroups= json_decode($SocialAutoPost->contents_get('https://graph.facebook.com/me/groups',array('access_token'=>$access_token,'limit'=>1000)));
        $groups=$SocialAutoPost->value($listGroups,'data');
        
        
        if(is_array($data) && !empty($data)){
            $data[]=(object) array(
                'access_token'=>$access_token,
                'id'=>$SocialAutoPost->value($user_profile,'identifier'),
                'name'=>$SocialAutoPost->value($user_profile,'displayName'),
                'type'=>'Account',
                'profileURL'=>$SocialAutoPost->value($user_profile,'profileURL')
            );
            
            if(is_array($groups) && !empty($groups)){
                foreach($groups as $group){
                    $data[]=(object) array(
                        'access_token'=>$access_token,
                        'id'=>$SocialAutoPost->value($group,'id'),
                        'name'=>$SocialAutoPost->value($group,'name'),
                        'type'=>'Group',
                        'profileURL'=>'https://www.facebook.com/'.$SocialAutoPost->value($group,'id')
                    );
                }
            }
            foreach($data as $d){
                $identifier=$SocialAutoPost->value($d,'id');
                $r=$wpdb->get_row( "SELECT * FROM ".$SocialAutoPost->get('db_prefix')."account where identifier='{$identifier}' limit 0,1",ARRAY_A);
                $fields=array(
                    'provider'=>$_REQUEST['provider'],
                    'identifier'=>$SocialAutoPost->value($d,'id'),
                    'access_token'=>$SocialAutoPost->value($d,'access_token'),
                    'name'=>$SocialAutoPost->value($d,'name'),
                    'profileURL'=>'https://www.facebook.com/'.$SocialAutoPost->value($d,'id'),
                    'created'=>time(),
                    'type'=>$SocialAutoPost->value($d,'type') ? $SocialAutoPost->value($d,'type'):'Page'
                );
                if(!$r){
                     $wpdb->insert( $SocialAutoPost->get('db_prefix').'account',$fields);
                }
                else {
                    $wpdb->update( $SocialAutoPost->get('db_prefix').'account',$fields,array('identifier'=>$identifier));
                }
            }
        }
    }
    else if(!empty($user_profile) && $_REQUEST['provider']=='LinkedIn'){
        $access_token_arr=$provider->getAccessToken();
        $access_token=$SocialAutoPost->value($_REQUEST,'access_token');
        
        $account=array();
        $account[]=array(
            'provider'=>$_REQUEST['provider'],
            'identifier'=>$SocialAutoPost->value($user_profile,'identifier'),
            'access_token'=>$SocialAutoPost->value($_REQUEST,'access_token'),
            'access_token_secret'=>$SocialAutoPost->value($access_token_arr,'access_token_secret'),
            'name'=>$SocialAutoPost->value($user_profile,'displayName'),
            'profileURL'=>$SocialAutoPost->value($user_profile,'profileURL'),
            'created'=>time(),
            'type'=>'Account'
        );
        
        
        $url_companies='https://api.linkedin.com/v1/companies?format=json&is-company-admin=true&oauth2_access_token='.$access_token;
        $companies = wp_remote_retrieve_body(wp_remote_get($url_companies, array(
                'body' => json_encode(array('format'=>'json','is-company-admin'=>true)),
                'headers' => array( 'Content-Type' => 'application/json','x-li-format'=>'json'),
        )));
        if($companies!=''){
            $companies_json=json_decode($companies);
            $companies_pages=$SocialAutoPost->value($companies_json,'values');
            if(is_array($companies_pages)){
                foreach($companies_pages as $companies_page){
                    $account[]=array(
                        'provider'=>$_REQUEST['provider'],
                        'identifier'=>$SocialAutoPost->value($companies_page,'id'),
                        'access_token'=>$SocialAutoPost->value($_REQUEST,'access_token'),
                        'access_token_secret'=>$SocialAutoPost->value($access_token_arr,'access_token_secret'),
                        'name'=>$SocialAutoPost->value($companies_page,'name'),
                        'profileURL'=>'https://www.linkedin.com/company/'.$SocialAutoPost->value($companies_page,'id'),
                        'created'=>time(),
                        'type'=>'Companies'
                    );
                }
            }
        }  
        
        foreach($account as $fields){
            $r=$wpdb->get_row( "SELECT * FROM ".$SocialAutoPost->get('db_prefix')."account where identifier='{$fields['identifier']}' limit 0,1",ARRAY_A);
            if(!$r){
                 $wpdb->insert( $SocialAutoPost->get('db_prefix').'account',$fields);
            }
            else {
                $wpdb->update( $SocialAutoPost->get('db_prefix').'account',$fields,array('identifier'=>$fields['identifier']));
            }
        }
    }
    else if(!empty($user_profile) && $_REQUEST['provider']=='Instagram'){
        $access_token_arr=$provider->getAccessToken();
        $identifier=$SocialAutoPost->value($user_profile,'identifier');
        $r=$wpdb->get_row( "SELECT * FROM ".$SocialAutoPost->get('db_prefix')."account where identifier='{$identifier}' limit 0,1",ARRAY_A);
        $fields=array(
            'provider'=>$_REQUEST['provider'],
            'identifier'=>$SocialAutoPost->value($user_profile,'identifier'),
            'access_token'=>$SocialAutoPost->value($access_token_arr,'access_token'),
            'access_token_secret'=>$SocialAutoPost->value($access_token_arr,'access_token_secret'),
            'name'=>$SocialAutoPost->value($user_profile,'displayName'),
            'created'=>time(),
            'type'=>'Account',
            'profileURL'=>'https://www.instagram.com/'.$SocialAutoPost->value($user_profile,'username'),
        );
        if(!$r){
             $wpdb->insert( $SocialAutoPost->get('db_prefix').'account',$fields);
        }
        else {
            $wpdb->update( $SocialAutoPost->get('db_prefix').'account',$fields,array('identifier'=>$identifier));
        }
        
    }
    else if(!empty($user_profile) && $_REQUEST['provider']=='Google'){
        $access_token_arr=$provider->getAccessToken();
        $identifier=$SocialAutoPost->value($user_profile,'identifier');
        $r=$wpdb->get_row( "SELECT * FROM ".$SocialAutoPost->get('db_prefix')."account where identifier='{$identifier}' limit 0,1",ARRAY_A);
        
        $fields=array(
            'provider'=>$_REQUEST['provider'],
            'identifier'=>$SocialAutoPost->value($user_profile,'identifier'),
            'access_token'=>$SocialAutoPost->value($access_token_arr,'access_token'),
            'refresh_token'=>$SocialAutoPost->value($access_token_arr,'refresh_token'),
            'name'=>$SocialAutoPost->value($user_profile,'displayName'),
            'profileURL'=>$SocialAutoPost->value($user_profile,'profileURL'),
            'created'=>time()
        );
        if(!$r){
             $wpdb->insert( $SocialAutoPost->get('db_prefix').'account',$fields);
        }
        else {
            $wpdb->update( $SocialAutoPost->get('db_prefix').'account',$fields,array('identifier'=>$identifier));
        }
    }
    wp_redirect(add_query_arg(array('page'=>'socialautopost-list-account','tab'=>$_REQUEST['provider']), site_url('wp-admin/admin.php')));
    $content= ob_get_contents(); 
    ob_end_clean();
}
catch( Exception $e ){
    echo "Ooophs, we got an error: " . $e->getMessage();
    exit();
}
?>
<?php exit();?>